﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Interactivity;

namespace GrafikaWPF
{
    class PrzesuwanieOkna : Behavior<Window>
    {
        protected override void OnAttached()
        {
            Window window = this.AssociatedObject;
            if(window != null)
            {
                window.KeyDown += Window_KeyDown;
                window.MouseDown += Window_MouseDown;
                window.MouseMove += Window_MouseMove;
                window.MouseUp += Window_MouseUp;
            }
        }

        private void Window_KeyDown(object sender, KeyEventArgs e)
        {

            if (e.Key == Key.Escape) (sender as Window).Close();
        }

        bool trwaPrzesuwanie = false;
        Point początkowaPozycjaKursora;

        private void Window_MouseDown(object sender, MouseButtonEventArgs e)
        {
            Window window = sender as Window;
            if(!trwaPrzesuwanie && e.LeftButton == MouseButtonState.Pressed)
            {
                trwaPrzesuwanie = true;
                początkowaPozycjaKursora = e.GetPosition(window);
            }
        }

        private void Window_MouseMove(object sender, MouseEventArgs e)
        {
            Window window = sender as Window;
            if(trwaPrzesuwanie)
            {
                Point pozycjaKursora = e.GetPosition(window);
                Vector przesunięcie = pozycjaKursora - początkowaPozycjaKursora;
                window.Left += przesunięcie.X;
                window.Top += przesunięcie.Y;
            }
        }

        private void Window_MouseUp(object sender, MouseButtonEventArgs e)
        {
            Window window = sender as Window;
            if(e.LeftButton == MouseButtonState.Released)
            {
                trwaPrzesuwanie = false;
            }
        }
    }
}
